package com.yongqi.xinrenli.service.impl;

import cn.hutool.core.bean.BeanUtil;
import com.ruoyi.common.utils.StringUtils;
import com.ruoyi.common.core.page.TableDataInfo;
import com.ruoyi.common.core.domain.PageQuery;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import lombok.RequiredArgsConstructor;
import org.springframework.stereotype.Service;
import com.yongqi.xinrenli.domain.bo.DbArticleBo;
import com.yongqi.xinrenli.domain.vo.DbArticleVo;
import com.yongqi.xinrenli.domain.DbArticle;
import com.yongqi.xinrenli.mapper.DbArticleMapper;
import com.yongqi.xinrenli.service.IDbArticleService;

import java.util.List;
import java.util.Map;
import java.util.Collection;

/**
 * 文章Service业务层处理
 *
 * @author zyf
 * @date 2023-03-09
 */
@RequiredArgsConstructor
@Service
public class DbArticleServiceImpl implements IDbArticleService {

    private final DbArticleMapper baseMapper;

    /**
     * 查询文章
     */
    @Override
    public DbArticleVo queryById(Long id) {
        return baseMapper.selectVoById(id);
    }

    /**
     * 查询文章列表
     */
    @Override
    public TableDataInfo<DbArticleVo> queryPageList(DbArticleBo bo, PageQuery pageQuery) {
        LambdaQueryWrapper<DbArticle> lqw = buildQueryWrapper(bo);
        Page<DbArticleVo> result = baseMapper.selectVoPage(pageQuery.build(), lqw);
        return TableDataInfo.build(result);
    }

    /**
     * 查询文章列表
     */
    @Override
    public List<DbArticleVo> queryList(DbArticleBo bo) {
        LambdaQueryWrapper<DbArticle> lqw = buildQueryWrapper(bo);
        return baseMapper.selectVoList(lqw);
    }

    private LambdaQueryWrapper<DbArticle> buildQueryWrapper(DbArticleBo bo) {
        Map<String, Object> params = bo.getParams();
        LambdaQueryWrapper<DbArticle> lqw = Wrappers.lambdaQuery();
        lqw.eq(StringUtils.isNotBlank(bo.getTitle()), DbArticle::getTitle, bo.getTitle());
        lqw.eq(StringUtils.isNotBlank(bo.getContent()), DbArticle::getContent, bo.getContent());
        lqw.eq(StringUtils.isNotBlank(bo.getCreateUser()), DbArticle::getCreateUser, bo.getCreateUser());
        lqw.eq(StringUtils.isNotBlank(bo.getModifyUser()), DbArticle::getModifyUser, bo.getModifyUser());
        lqw.eq(bo.getModifyTime() != null, DbArticle::getModifyTime, bo.getModifyTime());
        lqw.eq(bo.getDeleteStatus() != null, DbArticle::getDeleteStatus, bo.getDeleteStatus());
        return lqw;
    }

    /**
     * 新增文章
     */
    @Override
    public Boolean insertByBo(DbArticleBo bo) {
        DbArticle add = BeanUtil.toBean(bo, DbArticle.class);
        validEntityBeforeSave(add);
        boolean flag = baseMapper.insert(add) > 0;
        if (flag) {
            bo.setId(add.getId());
        }
        return flag;
    }

    /**
     * 修改文章
     */
    @Override
    public Boolean updateByBo(DbArticleBo bo) {
        DbArticle update = BeanUtil.toBean(bo, DbArticle.class);
        validEntityBeforeSave(update);
        return baseMapper.updateById(update) > 0;
    }

    /**
     * 保存前的数据校验
     */
    private void validEntityBeforeSave(DbArticle entity) {
        //TODO 做一些数据校验,如唯一约束
    }

    /**
     * 批量删除文章
     */
    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if (isValid) {
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return baseMapper.deleteBatchIds(ids) > 0;
    }
}
